import java.awt.*;
import java.net.*;
import java.util.*;
import java.applet.*;


class Message
{
    Color 	borderColor;	// Text Border color
    Color	textColor;	    // Text color of message
    String 	message;		// Message to display
    Font  	font;			// Font of message
    String	fontName;		// Font name
    int		fontType;		// BOLD, ITALIC, PLAIN
    int   	fontSize;		// Font size
    int 	begin;			// Start position for message (LEFT, RIGHT, UP, DOWN, FADE)
    int		end;			// End position for message (LEFT, RIGHT, UP, DOWN, FADE)
    int 	speed1;			// Fade and Text scrolling speed (0 - 30) - in
    int 	speed2;			// Fade and Text scrolling speed (0 - 30) - out
    int 	pause;			// Miliseconds to pause

    URL		urlLink;
    Color	urlColor;
    boolean bSetColor, bUrlLink, brolledOver;

    Message(Color borderColor, Color textColor, Font font, String fontName, int fontType, int fontSize,
                String message, int speed1, int speed2, int pause, int begin, int end, String sUrl, Color urlColor)
    {
        this.borderColor    = borderColor;
        this.textColor 	    = textColor;
        this.message 		= message;
        this.font 			= font;
        this.fontName		= fontName;
        this.fontType		= fontType;
        this.fontSize 		= fontSize;
        this.begin 			= begin;
        this.end 			= end;
        this.speed1 		= speed1;
        this.speed2 		= speed2;
        this.pause 			= pause;
        this.urlColor		= urlColor;
        this.bSetColor		= false;

        try
        {
            urlLink = new URL (sUrl);
            bUrlLink = true;
        }
        catch (MalformedURLException e)
        {
            bUrlLink = false;
        }
    }

    public boolean mouseBrowse(int x1, int y1, int xpos, int ypos, String currentString, FontMetrics fm)
    {
        int x2 = xpos + fm.stringWidth(currentString);
        int y2 = ypos + (fm.getHeight());

        if ((x1 >= xpos) && (y1 >= ypos - fm.getHeight()) && (x1 <= x2) && (y1 <= y2))
            return true;
        else
            return false;
    }

    public Color setUrlColor(Color currentColor)
    {
        if (bSetColor)
            return urlColor;
        else
            return currentColor;
    }

    public boolean getHighlight()
    {
        return bSetColor;
    }

    public void setHighlight(boolean state)
    {
        bSetColor = state;
    }

    public URL getUrl()
    {
        return urlLink;
    }
}

public class TextScroller extends Applet implements Runnable
{
    // Who is this guy?
    String WebAppstogo = "WebAppstogo.com";
    String Author = "TextScroller - Copyright(c) 2001 WebAppstogo";
    String Registered = "4JF3HWI4DMQ";
    Font hfont = new Font("TimesRoman", Font.ITALIC, 11);
    FontMetrics hfm = getFontMetrics(hfont);
    Color hColor;
    String szStatusWindow;
    boolean bAuthor = false;
    boolean bStatusWindow = false;
    boolean bUrlActive = false;
    boolean bSetHighlight = false;
    boolean bTrialVersion   = true;

    // Main thread
    Thread loopThread;

    // Create off screen image
    Image offImage;
    Graphics offScreen;

    // Set the font
    Font font;
    FontMetrics fm;

    // Message Vector
    Vector vMessage	= new Vector();

    int fontWidth;
    int fontHeight;
    int xpos, ypos;
    int position;
    int step;
    int currentMessage;
    int mx, my;

    Color border;
    Color currentColor;
    String currentString;

    int fadeDelay[] = { 0,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1 };
    int scrollDelay[] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30 };

    final int LEFT	= 1;
    final int RIGHT	= 2;
    final int UP 	= 3;
    final int DOWN 	= 4;
    final int FADE	= 5;
    final int ZOOM	= 6;

    int   	parmMessages;
    Font  	parmFont;
    String	parmFontName;
    int		parmFontType;
    int   	parmFontSize;
    int   	parmTextSpeed;
    int   	parmPause;
    String 	parmMessageText;
    Color 	parmTextColor;
    Color 	parmBorderColor;
    int		parmBeginPosition;
    int		parmEndPosition;
    int		parmTextDelay1;
    int		parmTextDelay2;
    Color	parmBackgroundColor;
    boolean borderColor;
    boolean backGround;

    Color 	defaultBorderColor 		= new Color (0,0,255);
    Color 	defaultTextColor 		= new Color (0,0,255);
    Color	defaultBackgroundColor  = new Color (0,0,0);
    Color	defaultURLColor			= new Color (0,0,255);
    int   	defaultTextSpeed 		= 5;
    int   	defaultPause 			= 1000;
    int		defaultBeginPosition	= UP;
    int		defaultEndPosition 		= DOWN;
    int		defaultDelay 			= scrollDelay[5];

    String	parmURL;
    Color	parmURLColor = defaultURLColor;

    Image   backGroundImage;
    String  url$;

    public void init()
    {
        Graphics g;
        Dimension d;

        // Find the size of the screen
        g = getGraphics();
        d = size();

        // Create the off screen images
        offImage = createImage(size().width, size().height);
        offScreen = offImage.getGraphics();

        // Grab all parameters
        String temp, temp2, szTemp;

        // Make sure Status param exists
        szStatusWindow = getParameter ("Status");
        if (szStatusWindow != null)
        {
            bStatusWindow = true;
        }

        // Registered Customer?
        String reg = getParameter ("Reg");
        if (reg != null)
        {
            if (reg.equalsIgnoreCase(Registered))
                bTrialVersion = false;
        }

        // Make sure author param exists
        szTemp = getParameter ("Author");
        if (szTemp != null)
        {
            if (szTemp.equalsIgnoreCase(Author))
            {
                bAuthor = true;
            }
        }

          // Get total messages to display
        String messages = getParameter ("messages");
        if (messages == null)
            parmMessages = 1;
        else
            parmMessages = Integer.parseInt(messages);

        for (int i=1; i<= parmMessages; i++)
        {
            // Back ground color
            temp = "background";
            String sBackGround = getParameter (temp);
            if (sBackGround == null)
            {
                parmBackgroundColor = defaultBackgroundColor;
            }
            else
            {
                parmBackgroundColor = getColor(getParameter(temp));
            }

            // Get Background Image, if provided by user
            temp = "backgroundimage";
            String sBackGroundImage = getParameter (temp);
            if (sBackGroundImage == null)
            {
                backGround = false;
            }
            else
            {
                try
                {
                    backGround = true;
                    backGroundImage = getImage(new URL(getDocumentBase(), sBackGroundImage));
                }
                catch (MalformedURLException e)
                {
                    backGround = false;
                }
            }

            // Text Border color
            temp = "border";
            String sBorder = getParameter (temp);
            if (sBorder == null)
            {
                borderColor = false;
            }
            else
            {
                borderColor = true;
                parmBorderColor = getColor(getParameter(temp));
            }

            // Set up FONT
            temp = "font" + String.valueOf(i);
            getFont(getParameter(temp), i);

            // Get a Message
            temp = "message" + String.valueOf(i);
            parmMessageText = getParameter (temp);
            if (parmMessageText == null)
                parmMessageText = "KEYWORD:  '" + temp + "' not defined!!!!";

            // Message Text Color
            temp = "textcolor" + String.valueOf(i);
            String sTextColor = getParameter (temp);
            if (sTextColor == null)
            {
                if (i == 1)
                    parmTextColor = defaultTextColor;
                else
                {
                    // If the user did not specify a text color then get it from the first time it was set
                    Message m = (Message)vMessage.elementAt(0);
                    parmTextColor = m.textColor;
                }
            }
            else
                parmTextColor = getColor(getParameter(temp));

            // Get URL
            temp = "url" + String.valueOf(i);
            parmURL = getParameter(temp);

            // Get URL color
            temp = "urlcolor" + String.valueOf(i);
            String sUrl = getParameter (temp);
            if (sUrl == null)
            {
                parmURLColor = defaultURLColor;
            }
            else
            {
                parmURLColor = getColor(getParameter(temp));
            }

            // Get parm pause (used to pause text on screen)
            temp = "pause" + String.valueOf(i);
            String tPause = getParameter (temp);
            if (tPause == null)
            {
                if (i == 1)
                    parmPause = defaultPause;
                else
                {
                    // If the user did not specify a text color then get it from the first time it was set
                    Message m = (Message)vMessage.elementAt(0);
                    parmPause = m.pause;
                }
            }
            else
            {
                try
                {
                    parmPause = Integer.parseInt(tPause);
                }
                catch (Exception e)
                {
                    parmPause = 2000;
                }
            }

            // Set up starting and ending position of text
            temp = "begin" + String.valueOf(i);
            temp2 = "end" + String.valueOf(i);
            getPosition(getParameter(temp), getParameter(temp2));

            // Add all this info to our Vector
            vMessage.addElement(new Message(parmBorderColor,parmTextColor,parmFont,parmFontName,parmFontType,parmFontSize,
                parmMessageText,parmTextDelay1,parmTextDelay2,parmPause,parmBeginPosition,parmEndPosition,parmURL,parmURLColor));
        }
    }

    void getFont(String param, int MessageNum)
    {
        String fSize = null;
        String tType = null;

        if (param != null)
        {
            try
            {
                StringTokenizer sFont = new StringTokenizer(param, ",");
                parmFontName = sFont.nextToken();
                fSize = sFont.nextToken();
                tType	 = sFont.nextToken();
            }
            catch (Exception e)
            {
                parmFontSize = 12;
                parmFontType = Font.PLAIN;
                parmFontName = "TimesRoman";
                parmFont = new Font(parmFontName, parmFontType, parmFontSize);
                return;
            }
        }

        if (tType == null || fSize == null || parmFontName == null)
        {
            if (MessageNum == 1)
            {
                Message m = (Message)vMessage.elementAt(0);
                parmFontSize = m.fontSize;
                parmFontType = m.fontType;
                parmFontName = m.fontName;
            }
        }
        else
        {
            if (tType.equalsIgnoreCase("plain"))
                parmFontType = Font.PLAIN;
            else if (tType.equalsIgnoreCase("italic"))
                parmFontType = Font.ITALIC;
            else
                parmFontType = Font.BOLD;

            try { parmFontSize = Integer.parseInt(fSize); }
            catch (Exception e)
            {
                parmFontSize = 10;
            }
        }

        try
        {
            parmFont = new Font(parmFontName, parmFontType, parmFontSize);
        }
        catch (Exception e)
        {
            parmFontSize = 12;
            parmFontType = Font.PLAIN;
            parmFontName = "TimesRoman";
            parmFont = new Font(parmFontName, parmFontType, parmFontSize);
        }
    }

    void getPosition(String param1, String param2)
    {
        StringTokenizer sPos1 = new StringTokenizer(param1, ",");
        StringTokenizer sPos2 = new StringTokenizer(param2, ",");

        try
        {
            String tBegin = sPos1.nextToken();
            String tEnd	   = sPos2.nextToken();
            String delay1 = sPos1.nextToken();
            String delay2 = sPos2.nextToken();

            try
            {
                parmTextDelay1 = Integer.parseInt(delay1);
                if (parmTextDelay1 < 1 || parmTextDelay1 > 30)
                    parmTextDelay1 = 10;
            }
            catch (Exception e)
            {
                parmTextDelay1 = scrollDelay[5];
            }

            try
            {
                parmTextDelay2 = Integer.parseInt(delay2);
                if (parmTextDelay2 < 1 || parmTextDelay2 > 30)
                    parmTextDelay2 = 10;
            }
            catch (Exception e)
            {
                parmTextDelay2 = scrollDelay[5];
            }

            // Get starting psition
            if (tBegin == null)
                parmBeginPosition = defaultBeginPosition;
            else
            {
                if (tBegin.equalsIgnoreCase("FADE"))
                    parmBeginPosition = FADE;
                else if (tBegin.equalsIgnoreCase("RIGHT"))
                    parmBeginPosition = RIGHT;
                else if (tBegin.equalsIgnoreCase("LEFT"))
                    parmBeginPosition = LEFT;
                else if (tBegin.equalsIgnoreCase("UP"))
                    parmBeginPosition = UP;
                else if (tBegin.equalsIgnoreCase("DOWN"))
                    parmBeginPosition = DOWN;
                else
                    parmBeginPosition = ZOOM;
            }

            // Get ending position
            if (tEnd == null)
                parmEndPosition = defaultEndPosition;
            else
            {
                if (tEnd.equalsIgnoreCase("FADE"))
                    parmEndPosition = FADE;
                else if (tEnd.equalsIgnoreCase("RIGHT"))
                    parmEndPosition = RIGHT;
                else if (tEnd.equalsIgnoreCase("LEFT"))
                    parmEndPosition = LEFT;
                else if (tEnd.equalsIgnoreCase("UP"))
                    parmEndPosition = UP;
                else if (tEnd.equalsIgnoreCase("DOWN"))
                    parmEndPosition = DOWN;
                else
                    parmEndPosition = ZOOM;
            }
        }
        catch (Exception e)
        {
            parmBeginPosition = defaultBeginPosition;
            parmEndPosition = defaultEndPosition;
            parmTextDelay1 = 10;
            parmTextDelay2 = 10;
        }
    }

    Color getColor(String param)
    {
        int r, g, b;
        // use StringTokenizer to parse the paramter which is
        // in "R,G,B" form. Then return the new Color.
        StringTokenizer st = new StringTokenizer(param, ",");
        try
        {
            r = Integer.parseInt(st.nextToken());
            g = Integer.parseInt(st.nextToken());
            b = Integer.parseInt(st.nextToken());
            return new Color(r, g, b);
        }
        catch (Exception e)
        {
            return defaultBorderColor;
        }
    }

    public void start()
    {
        if (loopThread == null)
        {
            loopThread = new Thread(this);
            loopThread.start();
        }
    }

    public void stop()
    {
        if (loopThread != null)
        {
            loopThread.stop();
            loopThread = null;
        }
    }

    public void run()
    {
        long startTime;

        // Show credits in status bar
        if (bStatusWindow && !bTrialVersion)
            showStatus(szStatusWindow);
        else
            showStatus(Author);

        // Lower this thread's priority and get the current time.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
        startTime = System.currentTimeMillis();

        // Main loop
      while (Thread.currentThread() == loopThread)
        {
            message();
            try
            {
                startTime += 100;
                Thread.sleep(Math.max(0, startTime - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
        }
    }

    public void message()
    {
        // Lets get it started
        for (int j=0; j<vMessage.size(); j++)
        {
            currentMessage = j;
            Message m = (Message)vMessage.elementAt(j);
            border = m.borderColor;
            currentString = m.message;
            currentColor = m.textColor;
            font = m.font;
            parmFontSize = m.fontSize;
            parmFontType = m.fontType;
            parmFontName = m.fontName;
            fm = getFontMetrics(font);

            scroll (m.begin, m.end, m.speed1, m.speed2, m.pause);
            m.bSetColor = false;
        }
    }

    public void scroll(int start, int end, int time1, int time2, int pause)
    {
        int size;
        int step1, step2;
        Message m = (Message)vMessage.elementAt(currentMessage);

        step1 = (time1 > 5 ? 1 : 2);
        step2 = (time2 > 5 ? 1 : 2);

        // Start Sequence
        switch (start)
        {
            case LEFT:
                for (int i=-fm.stringWidth(currentString); i<=((size().width - fm.stringWidth(currentString)) / 2); i+=step1)
                {
                    xpos = i;
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time1]);

                    // Highlight URL if needed
                if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                    m.setHighlight(true);
                else
                    m.setHighlight(false);
                }
                break;

            case RIGHT:
                for (int i=size().width; i>=((size().width - fm.stringWidth(currentString)) / 2); i-=step1)
                {
                    xpos = i;
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time1]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case UP:
                for (int i=0; i<=(size().height/2) + (fm.getHeight()/3) + 2; i+=step1)
                {
                    xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                    ypos = i;
                    repaint();
                    pause(scrollDelay[time1]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case DOWN:
                for (int i=size().height+fm.getHeight(); i>=(size().height/2) + (fm.getHeight()/3) + 2; i-=step1)
                {
                    xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                    ypos = i;
                    repaint();
                    pause(scrollDelay[time1]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case FADE:
                xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                fadeIn (currentColor.getRed(), currentColor.getGreen(), currentColor.getBlue(), fadeDelay[time1]);
                break;

            case ZOOM:
                size = 1;

                while (true)
                {
                    parmFont = new Font(parmFontName, parmFontType, size++);
                    font = parmFont;
                    fm = getFontMetrics(font);
                    xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time1]);

                    if (size > parmFontSize)
                        break;
                }
                break;
        }

        // Pause between transition
        pause (pause);

        // End Sequence
        switch (end)
        {
            case LEFT:
                for (int i=((size().width - fm.stringWidth(currentString)) / 2); i>=-fm.stringWidth(currentString); i-=step2)
                {
                    xpos = i;
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time2]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case RIGHT:
                for (int i=((size().width - fm.stringWidth(currentString)) / 2); i<size().width+5; i+=step2)
                {
                    xpos = i;
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time2]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case UP:
                for (int i=(size().height/2) + (fm.getHeight()/3) + 2; i>=-fm.getHeight(); i-=step2)
                {
                    // Commented out because text jumping 1 pixel
                    //xpos = position;
                    ypos = i;
                    repaint();
                    pause(scrollDelay[time2]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case DOWN:
                for (int i=(size().height/2) + (fm.getHeight()/3) + 2; i<=size().height+fm.getHeight(); i+=step2)
                {
                    // Commented out because text jumping 1 pixel
                    //xpos = position;
                    ypos = i;
                    repaint();
                    pause(scrollDelay[time2]);

                    // Highlight URL if needed
                    if (m.mouseBrowse(mx, my, xpos, ypos, currentString, fm))
                        m.setHighlight(true);
                    else
                        m.setHighlight(false);
                }
                break;

            case FADE:
                // Commented out because text jumping 1 pixel
                //xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                //ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                fadeOut (currentColor.getRed(), currentColor.getGreen(), currentColor.getBlue(), fadeDelay[time2]);
                break;

            case ZOOM:
                size = parmFontSize;

                while (true)
                {
                    parmFont = new Font(parmFontName, parmFontType, size--);
                    font = parmFont;
                    fm = getFontMetrics(font);
                    xpos = ((size().width - fm.stringWidth(currentString)) / 2);
                    ypos = (size().height/2) + (fm.getHeight()/3) + 2;
                    repaint();
                    pause(scrollDelay[time2]);

                    if (size <= 0)
                        break;
                }
                break;
        }
    }

    public void fadeIn(int r1, int g1, int b1, int step)
    {
        int r=parmBackgroundColor.getRed();		// 0
        int g=parmBackgroundColor.getGreen();	// 0
        int b=parmBackgroundColor.getBlue();	// 255

        boolean red = (r > r1 ? true : false);
        boolean green = (g > g1 ? true : false);
        boolean blue = (b > b1 ? true : false);

        while (true)
        {
            if (red)
            {
                r-=step;
                if (r < r1)
                    r = r1;
            }
            else
            {
                r+=step;
                if (r > r1)
                    r = r1;
            }

            if (green)
            {
                g-=step;
                if (g < g1)
                    g = g1;
            }
            else
            {
                g+=step;
                if (g > g1)
                    g = g1;
            }

            if (blue)
            {
                b-=step;
                if (b < b1)
                    b = b1;
            }
            else
            {
                b+=step;
                if (b > b1)
                    b = b1;
            }

            currentColor = new Color (r,g,b);
            repaint();
            pause(20);

            if (r==r1 && g==g1 && b==b1)
                break;
        }
    }

    public void fadeOut(int r, int g, int b, int step)
    {
        int r1=parmBackgroundColor.getRed();	// 0
        int g1=parmBackgroundColor.getGreen();	// 0
        int b1=parmBackgroundColor.getBlue();	// 255

        boolean red = (r > r1 ? true : false);
        boolean green = (g > g1 ? true : false);
        boolean blue = (b > b1 ? true : false);

        while (true)
        {
            if (red)
            {
                r-=step;
                if (r < r1)
                    r = r1;
            }
            else
            {
                r+=step;
                if (r > r1)
                    r = r1;
            }

            if (green)
            {
                g-=step;
                if (g < g1)
                    g = g1;
            }
            else
            {
                g+=step;
                if (g > g1)
                    g = g1;
            }

            if (blue)
            {
                b-=step;
                if (b < b1)
                    b = b1;
            }
            else
            {
                b+=step;
                if (b > b1)
                    b = b1;
            }

            currentColor = new Color (r,g,b);
            repaint();
            pause(20);

            if (r==r1 && g==g1 && b==b1)
                break;
        }
 }

    public int getRandom(int min, int max)
    {
        Random r = new Random();
        min += (int)(r.nextDouble()*max);
        return min;
    }

    public void pause(int time)
    {
        try
        {
            Thread.sleep(time);
        }
        catch (InterruptedException e) { }
    }

    public boolean mouseBrowse(int x1, int y1, int xpos, int ypos, String currentString, FontMetrics fm)
    {
        int x2 = xpos + fm.stringWidth(currentString);
        int y2 = ypos + (fm.getHeight());

        if ((x1 >= xpos) && (y1 >= ypos - fm.getHeight()) && (x1 <= x2) && (y1 <= y2))
            return true;
        else
            return false;
    }

    public boolean mouseMove(Event evt, int x, int y)
    {
        mx = x;
        my = y;
        Message m = (Message)vMessage.elementAt(currentMessage);
        if (m.mouseBrowse(x, y, xpos, ypos, currentString, fm))
            m.setHighlight(true);
        else
            m.setHighlight(false);

        int xPos = (size().width - hfm.stringWidth(WebAppstogo) - 5);
        int yPos = (size().height) - (hfm.getHeight() - 15);

        if (mouseBrowse(x, y, xPos, yPos, WebAppstogo, hfm))
            bSetHighlight = true;
        else
            bSetHighlight = false;

         return true;
    }

    public boolean mouseExit(Event evt, int x, int y)
    {
        mx = 9999;
        my = 9999;
        Message m = (Message)vMessage.elementAt(currentMessage);
        m.setHighlight(false);

        // Reset highlight flag;
        bSetHighlight = false;

        return true;
    }

    public boolean mouseEnter(Event evt, int x, int y)
    {
        mx = x;
        my = y;
        Message m = (Message)vMessage.elementAt(currentMessage);
        if (m.mouseBrowse(x, y, xpos, ypos, currentString, fm))
            m.setHighlight(true);
        else
            m.setHighlight(false);
        return true;
    }

    public boolean mouseDown(Event evt, int x, int y)
    {
        if (bUrlActive)
            return true;

        Message m = (Message)vMessage.elementAt(currentMessage);
        if (m.mouseBrowse(x, y, xpos, ypos, currentString, fm))
        {
            try
            {
                AppletContext context = getAppletContext();
                context.showDocument(m.getUrl());
            }
            catch(Exception e)
            {}
        }

        if (bSetHighlight && bTrialVersion)
        {
            try
            {
                AppletContext context = getAppletContext();
                context.showDocument(new URL("http://centurionx.com/webappstogo"));
            }
            catch (MalformedURLException e){}
            bUrlActive = true;
            return true;
        }

        return true;
    }

    public void paint(Graphics g)
    {
        update(g);
    }

    public void update (Graphics g)
    {
        offScreen.setColor(Color.black);
        offScreen.fillRect(0,0,size().width,size().height);

        Message m = (Message)vMessage.elementAt(currentMessage);

        if (!bAuthor)
        {
            offScreen.setColor(Color.red);
            offScreen.drawString("Fill in author value with", 0, size().height/2);
            offScreen.drawString(Author, 0, size().height/2 + hfm.getHeight());
        }
        else
        {
            offScreen.setFont(font);

            offScreen.setColor(parmBackgroundColor);
            offScreen.fillRect(0,0,size().width,size().height);

            if (m.bUrlLink)
                offScreen.setColor(m.setUrlColor(currentColor));
            else
                offScreen.setColor(currentColor);

            // Draw background image
            if (backGround)
                offScreen.drawImage (backGroundImage, 0, 0, this);

            // Draw text string
            offScreen.drawString (currentString, xpos, ypos);

            // Draw Border
            if (borderColor)
            {
                offScreen.setColor(border);
                for (int z=0; z<=5; z++)
                    offScreen.drawRoundRect (0+z,0+z,size().width-z-1,size().height-z-1,10,8);
            }

            if (bTrialVersion)
            {
                // Draw Company name
                if (bSetHighlight)
                {
                    setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
                    offScreen.setColor(Color.blue);
                }
                else
                {
                    setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
                    offScreen.setColor(Color.black);
                }

                int x = (size().width - hfm.stringWidth(WebAppstogo) - 5);
                int y = (size().height) - (hfm.getHeight() - 10);
                offScreen.setFont(hfont);
                offScreen.drawString (WebAppstogo, x, y);
            }
        }
        // Show it
        g.drawImage(offImage, 0, 0, this);
    }
}